import { Component } from '@angular/core';
import { NgxEditorModel } from 'ngx-monaco-editor-v2'

@Component({
  selector: 'app-monaco-editor',
  templateUrl: './monaco-editor-test.component.html',
  styleUrls: ['./monaco-editor-test.component.scss']
})
export class MonacoEditorTestComponent {

  onInit(editor: any) {
    let line = editor.getPosition();
    console.log(line);
  }

  languages = ['java', 'csharp', 'python', 'html'];
  theme: string = 'vs-dark';

  ts_placeholder: string =
    `//typescript placeholder function
  function printHello () {
    console.log("Hello world!");
  }`;

  java_placeholder: string =
    `//java placeholder class
  public class TestHelloWorld {
    public static void main (String [] args){
      System.out.println("Hello World");
    }
  }`;

  csharp_placeholder: string =
    `//csharp placeholder class
  using System;
  namespace Demo
  {
    public class TestHelloWorld
    {
      Console.WriteLine("Hello World");
    }
  }`;
  json_placeholder: string = '';

  html_placeholder: string = `
  <html>
    <title>Monaco editor integration</title>
    <body>
      <!-- the body of the page -->
    </body>
  </html>`;

  css_placeholder: string = '';

  python_placeholder: string = `
  class ClassName {
    __init__(){}
    def method() {

    }
  }`;

  monacoOptions = {
    theme: this.theme,
    automaticLayout: true,
    quickSuggestions: {
      other: 'inline',
      comments: true,
      strings : true
    },
    wordBasedSuggestions: true,
    glyphMargin: true,
    fontSize: 20,
    fixedOverflowWidgets: true,
    acceptSuggestionOnEnter: "on",
    };

  placeholders: Array<string> = [
    this.java_placeholder, 
    this.csharp_placeholder, 
    this.python_placeholder, 
    this.html_placeholder,
    this.json_placeholder,
    this.css_placeholder
  ]

  model: NgxEditorModel = {
    value: this.placeholders[0],
    language: this.languages[0],
  }
}
